<?php

class Bz2Mantis {
    private $dbLink;
    private $bzName;
    private $mtName;
    private $writes;
    private $errors;
    private $maps;
    
    function __construct($config) {
        $this->dbLink = mysql_connect($config['dbHOST'], $config['dbUSER'], $config['dbPASS']);
        $err = "";
        if (!$this->dbLink) {
            $err = mysql_error($this->dbLink);
        } else {
            $this->mtName = $config['mantisDB'];
            $this->bzName = $config['bugzillaDB'];
        }
        $this->maps   = $config['maps'];
        $this->errors = 0;
        $this->writes = 0;
        $this->mesg("MySQL Connect",$err);
    }

    private function mesg($action, $err="") {
        if ($err != "") {
            echo '<tr class="Error">';
            $this->errors++;
        } else {
            echo '<tr class="Msg">';
            $this->writes++;
        }
        echo "<td>".$action."</td>";
        echo "<td>".$err."</td>";
        echo "</tr>";        
    }
    
    private function header($from,$to) {
        echo "<tr><th>".$from."</th><th>".$to."</th></tr>";
    }

    function write($sql, $hide=false) {
        $err = "";
        if ($this->mtName) {
            mysql_select_db($this->mtName,$this->dbLink);
            $query = mysql_query($sql,$this->dbLink);
            if (!$query) {
                $err = mysql_error($this->dbLink);
            }
            if ($hide) {
                // Try to match only the ID
                if (preg_match("/ id=\S*/",$sql,$matches) > 0) {
                    $sql = $matches[0];
                } else {
                    $sql = "Item";
                }
            } 
        }
        $this->mesg($sql,$err);
    }
   
    function doSingleQuery($query) {
        mysql_select_db($this->bzName,$this->dbLink);
        $result = mysql_query($query);
        $row = mysql_fetch_array($result);
        return $row[0];
    }
   
    /**
     * Get the maximum value on a row
     * 
     * @param $table Table name
     * @param $row     Row name
     */
    function getMax($table,$row) {
        mysql_select_db($this->bzName,$this->dbLink);
        $res = mysql_query("SELECT MAX(".$row.") FROM ".$table);
        $row = mysql_fetch_array($res);
        return $row[0];        
    }
    
    /**
     * To examine the field_defs bugzilla table
     * 
     * @param unknown_type $id
     */
    function getFieldName($id) {
        $query = "SELECT name FROM fielddefs WHERE id=".$id;
        return $this->doSingleQuery($query);
    }
    
    /**
     * Pass rows from one table to a callback
     * 
     * @param Table to read rows $table
     * @param Function to pass the rows $callback
     */
    function mapTable($table, $callback, $hide=false) {
        $this->header($table,$callback);
        $query = "SELECT * FROM ".$table;
        mysql_select_db($this->bzName,$this->dbLink);
        $result = mysql_query($query);
        while ($row = mysql_fetch_assoc($result)) {
            $sql = call_user_func($callback,$row);
            foreach ($sql as $sentence) {
                $this->write($sentence, $hide);
            }           
        }
    }
    
    /**
     * Finish and output some summyar
     */
    function finish() {
        $this->header("Total Writes","Total Errors");
        $this->header($this->writes,$this->errors);
    }
    
    /**
     * Does the preconfigure mapping of fields
     *
     * @param The type of map (field or type) $mappingType
     * @param $value   The bugzilla value for the field.
     */    
    function getMapping($mappingType, $value) {
        $item = ($mappingType == "field" or $mappingType == "type" )
            ? $this->getFieldName($value)
            : $value;
        return $this->maps[$mappingType][$item];
    }
}

?>
